Locales

## Namespaces

namespace | std::__detail

## Classes

class | std::codecvt< _InternT, _ExternT, _StateT >
class | std::ctype< _CharT >
class | std::ctype< char >
class | std::ctype< wchar_t >
class | std::locale::facet
class | std::locale::id
class | std::locale
class | std::messages< _CharT >
struct | std::messages_base
class | std::money_base
class | std::money_get< _CharT, _InIter >
class | std::money_put< _CharT, _OutIter >
class | std::moneypunct< _CharT, _Intl >
class | std::num_get< _CharT, _InIter >
class | std::num_put< _CharT, _OutIter >
class | std::numpunct< _CharT >
class | std::time_base
class | std::time_get< _CharT, _InIter >
class | std::time_put< _CharT, _OutIter >
class | std::wbuffer_convert< _Codecvt, _Elem, _Tr >
class | std::wstring_convert< _Codecvt, _Elem, _Wide_alloc, _Byte_alloc >

## Functions

template<typename _OutStr, typename _InChar, typename _Codecvt, typename _State, typename _Fn>
bool | std::__do_str_codecvt (const _InChar *__first, const _InChar *__last, _OutStr &__outstr, const _Codecvt &__cvt, _State &__state, size_t &__count, _Fn __fn)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_in (const char *__first, const char *__last, basic_string< _CharT, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_in (const char *__first, const char *__last, basic_string< _CharT, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt, _State &__state, size_t &__count)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_in_all (const char *__first, const char *__last, basic_string< _CharT, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_out (const _CharT *__first, const _CharT *__last, basic_string< char, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_out (const _CharT *__first, const _CharT *__last, basic_string< char, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt, _State &__state, size_t &__count)
template<typename _CharT, typename _Traits, typename _Alloc, typename _State>
bool | std::__str_codecvt_out_all (const _CharT *__first, const _CharT *__last, basic_string< char, _Traits, _Alloc > &__outstr, const codecvt< _CharT, char, _State > &__cvt)
template<typename _Facet>
bool | std::has_facet (const locale &__loc)
template<typename _Facet>
const _Facet & | std::use_facet (const locale &__loc)

## Detailed Description

Classes and functions for internationalization and localization.

## Function Documentation

## __do_str_codecvt()

template<typename _OutStr, typename _InChar, typename _Codecvt, typename _State, typename _Fn>

bool std::__do_str_codecvt | ( | const _InChar * | __first,
|  | const _InChar * | __last,
|  | _OutStr & | __outstr,
|  | const _Codecvt & | __cvt,
|  | _State & | __state,
|  | size_t & | __count,
|  | _Fn | __fn )

Definition at line 54 of file locale_conv.h.

## __str_codecvt_in() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_in | ( | const char * | __first,
|  | const char * | __last,
|  | basic_string< _CharT, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt )

inline

Definition at line 128 of file locale_conv.h.

## __str_codecvt_in() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_in | ( | const char * | __first,
|  | const char * | __last,
|  | basic_string< _CharT, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt,
|  | _State & | __state,
|  | size_t & | __count )

inline

Definition at line 110 of file locale_conv.h.

## __str_codecvt_in_all()

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_in_all | ( | const char * | __first,
|  | const char * | __last,
|  | basic_string< _CharT, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt )

inline

Definition at line 140 of file locale_conv.h.

## __str_codecvt_out() [1/2]

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_out | ( | const _CharT * | __first,
|  | const _CharT * | __last,
|  | basic_string< char, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt )

inline

Definition at line 171 of file locale_conv.h.

## __str_codecvt_out() [2/2]

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_out | ( | const _CharT * | __first,
|  | const _CharT * | __last,
|  | basic_string< char, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt,
|  | _State & | __state,
|  | size_t & | __count )

inline

Definition at line 153 of file locale_conv.h.

## __str_codecvt_out_all()

template<typename _CharT, typename _Traits, typename _Alloc, typename _State>

bool std::__str_codecvt_out_all | ( | const _CharT * | __first,
|  | const _CharT * | __last,
|  | basic_string< char, _Traits, _Alloc > & | __outstr,
|  | const codecvt< _CharT, char, _State > & | __cvt )

inline

Definition at line 183 of file locale_conv.h.

## has_facet()

template<typename _Facet>

bool std::has_facet | ( | const locale & | __loc | ) |

inline nodiscard noexcept

Test for the presence of a facet.

has_facet tests the locale argument for the presence of the facet type provided as the template parameter. Facets derived from the facet parameter will also return true.

Template Parameters

  _Facet | The facet type to test the presence of.

Parameters

  __loc | The locale to test.

Returns
  true if `__loc` contains a facet of type _Facet, else false.

Definition at line 190 of file locale_classes.tcc.

## use_facet()

template<typename _Facet>

const _Facet & std::use_facet | ( | const locale & | __loc | ) |

inline nodiscard

Return a facet.

use_facet looks for and returns a reference to a facet of type Facet where Facet is the template parameter. If has_facet(locale) is true, there is a suitable facet to return. It throws std::bad_cast if the locale doesn't contain a facet of type Facet.

Template Parameters

  _Facet | The facet type to access.

Parameters

  __loc | The locale to use.

Returns
  Reference to facet of type Facet.

Exceptions

  std::bad_cast | if `__loc` doesn't contain a facet of type _Facet.

Definition at line 220 of file locale_classes.tcc.

Referenced by std::money_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get(), std::time_get< _CharT, _InIter >::do_get_date(), std::time_get< _CharT, _InIter >::do_get_monthname(), std::time_get< _CharT, _InIter >::do_get_time(), std::time_get< _CharT, _InIter >::do_get_weekday(), std::time_get< _CharT, _InIter >::do_get_year(), std::money_put< _CharT, _OutIter >::do_put(), std::time_put< _CharT, _OutIter >::do_put(), std::time_get< _CharT, _InIter >::get(), isalnum(), isalpha(), isblank(), iscntrl(), std::regex_traits< _Ch_type >::isctype(), isdigit(), isgraph(), islower(), isprint(), ispunct(), isspace(), isupper(), isxdigit(), std::regex_traits< _Ch_type >::lookup_classname(), std::regex_traits< _Ch_type >::lookup_collatename(), std::basic_ostream< _CharT, _Traits >::operator<<(), std::basic_istream< _CharT, _Traits >::operator>>(), operator>>(), operator>>(), std::time_put< _CharT, _OutIter >::put(), tolower(), toupper(), std::regex_traits< _CharT >::transform(), std::regex_traits< _CharT >::transform_primary(), std::regex_traits< _CharT >::translate_nocase(), std::regex_traits< _Ch_type >::value(), and ws().